.model compact,pascal
data      segment word public
          extrn dot: word
          extrn shademask: word
          extrn bitmapwidth: word
          extrn bitmapseg: word
          extrn bitmapofs: word
          extrn dotwidth: word
          extrn dotshade: word
data      ends
code      segment byte public
          assume cs:code,ds:data
;procedure drawdot(x,y: integer);
          public drawdot
drawdot   proc x: word, y: word
          mov ax,bitmapseg
          mov es,ax               ; es = seg(bitmap)
          mov ax,y
          mov bx,bitmapwidth
          mul bx                  ; ax = y*bitmapwidth
          mov di,x
          mov cl,3
          shr di,cl               ; di = x shr 3
          add di,ax               ; di = (x shr 3)+y*bitmapwidth
          add di,bitmapofs        ; di = ofs(bitmap[y,x shr 3])
          mov si,dotwidth
          mov cl,4
          shl si,cl               ; si = dotwidth*16
          add si,offset dot - 16  ; si = ofs(dot[w,0])
          mov bx,dotshade
          mov cl,5
          shl bx,cl               ; bx = dotshade*32
          mov ax,y
          and ax,7
          shl ax,1                ; ax = (y and 7)*2
          add bx,ax               ; bx = dotshade*32+(y and 7)*2
          add bx,offset shademask ; bx = ofs(shademask[dotshade,y and 7])
          mov dx,x
          and dx,7                ; dl = x and 7
          mov cx,8                ; cx will run 8..1, 8-cx will run 0..7
      l1: mov ax,[si]             ; ax = dot[w,8-cx]
          or ax,ax
          jz l2
          xchg cl,dl
          shr ax,cl               ; ax = dot[w,8-cx] shr (x and 7)
          xchg cl,dl
          and ax,[bx]             ; and ax,shademask[dotshade,(y and 7)+8-cx]
          xchg ah,al
          or es:[di],ax           ; or word ptr bitmap[y+8-cx,x shr 3],ax
      l2: add di,bitmapwidth
          add si,2
          add bx,2
          loop l1
          ret
drawdot   endp
code      ends
          end